#!/usr/bin/pypy3

import sys
import itertools
sys.setrecursionlimit(500000)

fi = open('isosis.txt', 'rt')
fo = open('isoval.txt', 'wt')

ints = iter(map(int, fi.read().split()))

def debug(n):
	sys.stderr.write(n)
	sys.stderr.write('\n')

memory = {}
def compress(seq):
	key = str(sorted(seq))
	if key not in memory:
		#debug('compress {key} -> {len(memory)}')
		memory[key] = len(memory)
	return memory[key]

n = next(ints)
nbors = [[] for _ in range(2*n)]
ord_nbors = [[] for _ in range(2*n)]
label = [-1 for _ in range(2*n)]
dist = [-1 for _ in range(2*n)]
for _ in range(n-1):
	a, b = next(ints), next(ints)
	nbors[a].append(b)
	nbors[b].append(a)
for _ in range(n-1):
	a, b = next(ints)+n, next(ints)+n
	nbors[a].append(b)
	nbors[b].append(a)

queue_i = 0
queue = []
for a in range(2*n):
	if len(nbors[a]) == 1:
		queue.append(a)
while queue_i < len(queue):
	a = queue[queue_i]; queue_i += 1
	for b in nbors[a]:
		if dist[b] == -1:
			ord_nbors[b].append(a)
			if len(ord_nbors[b])+1 == len(nbors[b]):
				queue.append(b)
				dist[b] = dist[a]+1

max_dist = max((dist[i] for i in range(2*n)))
aroots = []
broots = []
for a in range(2*n):
	if dist[a] == max_dist:
		if a < n:
			aroots.append(a)
		else:
			broots.append(a)
if len(aroots) == 0 or len(broots) == 0:
	fo.write('EI\n')
	sys.exit(0)

class MatchFailure(Exception):
	pass

perm = [-1 for _ in range(n)]
def match(aa, ap, ba, bp):
	#debug('match {aa}/{label[aa]} {ba-n}/{label[ba]}')
	if label[aa] != label[ba]:
		raise MatchFailure()
	perm[aa] = ba-n
	ans = sorted(nbors[aa], key=lambda i: label[i])
	bns = sorted(nbors[ba], key=lambda i: label[i])
	try:
		ans.remove(ap)
	except: pass
	try:
		bns.remove(bp)
	except: pass
	for ac, bc in zip(ans, bns):
		match(ac, aa, bc, ba)

def classify(a, p):
	info = []
	for b in nbors[a]:
		if b == p:
			continue
		classify(b, a)
		info.append(label[b])
	label[a] = compress(info)

aroot = aroots[0]
classify(aroot, aroot)
for broot in broots:
	try:
		#debug('try {aroot} {broot}')
		classify(broot, broot)
		match(aroot, aroot, broot, broot)
		fo.write('JAH\n')
		fo.write(' '.join(map(str, perm))+'\n')
		fi.close()
		fo.close()
		sys.exit(0)
	except MatchFailure:
		pass

fo.write('EI\n')
fi.close()
fo.close()
sys.exit(0)
