#include <algorithm>
#include <vector>
#include <stdio.h>
#include <iostream>
#include <cassert>
#include <cstdint>
#include <ios>
using namespace std;

FILE *fi = fopen("isosis.txt", "rt");
FILE *fo = fopen("isoval.txt", "wt");

#define ran(i, a, b) for (int i = (a); i < (int)(b); i++)
static int get() { int n; scanf("%i", &n); return n; }
using ll = long long;
using u64 = uint64_t;
using vi = vector<int>;
using ii = pair<int, int>;
#if defined(SHIROKO1_LOCAL) && !defined(STFU)
#define DEBUG(x) cerr << x << endl;
#else
#define DEBUG(...) ((void)0)
#endif

static u64 mix(u64 a)
{
#if 1
	u64 mem[2] = { a, 0xdeadbeeffeebdaedull };
	asm volatile (
		"pxor %%xmm0, %%xmm0;"
		"movdqa (%0), %%xmm1;"
		"aesenc %%xmm0, %%xmm1;"
		"movdqa %%xmm1, (%0);"
		:
		: "r" (&mem[0])
		: "memory"
	);
	return mem[0];
#else
	a += 0xdeadbeeffeebdaedull;
	a ^= (a>>3)|(a<<64-3);
	a += (a>>9)|(a<<64-9);
	a ^= (a<<27)|(a>>64-27);
	a += (a<<17)|(a>>64-17);
#endif
	return a;
}

struct Tree {
	int size;
	vi *nbors;
	u64 *hsum;
	Tree() {}
	Tree(int n) : size(n), nbors(new vi[size]), hsum(new u64[size]) {}
	void add(int a, int b)
	{
		nbors[a].push_back(b);
		nbors[b].push_back(a);
	}

	void dfs_up(int a, int p)
	{
		hsum[a] = 1;
		for (int b : nbors[a]) if (b != p) {
			dfs_up(b, a);
			hsum[a] += mix(hsum[b]);
		}
	}

	void dfs_down(int a, int p, u64 h)
	{
		hsum[a] += h;
		DEBUG(a << ": " << hex << hsum[a]);
		for (int b : nbors[a]) if (b != p) {
			dfs_down(b, a, mix(hsum[a] - mix(hsum[b])));
		}
	}

	void hash()
	{
		dfs_up(0, 0);
		dfs_down(0, 0, 0);
		ran (i, 0, size) {
			sort(nbors[i].begin(), nbors[i].end(), [=](int a, int b) {
				return hsum[a] < hsum[b];
			});
		}
	}

	void read(FILE *f)
	{
		ran (i, 0, size-1) {
			int a, b;
			fscanf(f, "%i%i", &a, &b);
			add(a, b);
		}
	}
};

static int *ans;
static Tree A, B;

static void fail()
{
	fprintf(fo, "EI\n");
	exit(0);
}

static void match(int aa, int ap, int ba, int bp)
{
	DEBUG("MATCH " << aa << " <-> " << ba);
	ans[aa] = ba;
	if (A.hsum[aa] != B.hsum[ba])
		fail();
	assert(A.nbors[aa].size() == B.nbors[ba].size());
	int j = 0;
	ran (i, 0, (int)A.nbors[aa].size()) {
		if (A.nbors[aa][i] == ap) {
			continue;
		} else {
			if (B.nbors[ba][j] == bp)
				j++;
			match(A.nbors[aa][i], aa, B.nbors[ba][j++], ba);
		}
	}
}

int main()
{
	int n;
	fscanf(fi, "%i", &n);
	A = Tree(n);
	B = Tree(n);
	cerr << "reading tree..." << endl;
	A.read(fi);
	cerr << "hashing tree..." << endl;
	A.hash();
	cerr << "reading tree..." << endl;
	B.read(fi);
	cerr << "hashing tree..." << endl;
	B.hash();
	cerr << "matching..." << endl;
	ans = new int[n];

	int aroot = 0;
	int broot = -1;
	ran (i, 0, n) {
		if (A.hsum[aroot] == B.hsum[i]) {
			broot = i;
			break;
		}
	}
	if (broot == -1)
		fail();

	match(aroot, aroot, broot, broot);
	cerr << "done" << endl;
	fprintf(fo, "JAH\n");
	ran (i, 0, n)
		fprintf(fo, "%i\n", ans[i]);
	return 0;
}
