#include "/home/tahvend/comprog/jngen/jngen/jngen.h"
#include <fstream>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;

using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
/*
int main(){
	ordered_set<int>  cur;
	cur.insert(1); 
	cur.insert(3);
	cout << cur.order_of_key(2) << endl; // the number of elements in the set less than 2
	cout << *cur.find_by_order(0) << endl; // the 0-th smallest number in the set(0-based)
	cout << *cur.find_by_order(1) << endl; // the 1-th smallest number in the set(0-based)
}
*/

Graph deg2tree (int vertexc, int elongation) {
  Graph ans;

  ordered_set<pair<int, int>> frees;
  for (int i = 0; i < 3; i++) {
    frees.insert(make_pair(0, 3));
  }
  
  for (int i = 1; i < vertexc; i++) {
    auto par = frees.find_by_order(rnd.wnext(i, elongation));
    int parentId = (*par).first;
    frees.erase(par);
    ans.addEdge(parentId, i);
    frees.insert(make_pair(i, 0));
    frees.insert(make_pair(i, 1));
  }

  return ans;
}

int main () {
  int id = 2;
  for (int i = 0; i < 15; i += 4) {
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = deg2tree(1000, i).shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }

  for (int i = 0; i < 15; i += 4) {
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = Tree::randomPrim(1000, i).shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }

  for (int i = 0; i < 15; i += 4){
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = Graph::randomStretched(1000, 1000, i, 1 + (1 << (i / 2))).g().shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }
  
  for (int i = 0; i < 15; i += 4) {
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = deg2tree(50000, i).shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }

  for (int i = 0; i < 15; i += 4) {
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = Tree::randomPrim(50000, i).shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }
  
  for (int i = 0; i < 15; i += 4){
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = Graph::randomStretched(50000, 50000, i, 1 + (1 << (i / 2))).g().shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }

  for (int i = 0; i < 15; i += 3){
    ofstream fout ((string("input") + to_string(id) + string(".txt")).c_str());
    Graph g = Graph::random(50000, 50001 + i * 10000).allowMulti(false).connected(true).g().shuffled();
    fout << g.n() << " " << g.m() << endl;
    fout << g.add1() << endl;
    fout.close();
    id++;
  }  
}
