from collections import deque
import sys
sys.setrecursionlimit(50050)

fin = open("linnsis.txt", "r")
fout = open("linnval.txt", "w")

def make_edge (u, v):
    return (min(u, v), max(u, v))

MAX_V = 100005
adj = [[] for i in range(MAX_V)]
colors = ["punane", "sinine", "roheline"]
edge_color = {}

def tree_dfs (vertex, parent, cur_color):
    for nxt in adj[vertex]:
        if nxt != parent:
            cur_color = (cur_color + 1) % 3
            edge_color[make_edge(vertex, nxt)] = colors[cur_color]
            tree_dfs(nxt, vertex, cur_color)

def tree_solve (vertexc, edgec):
    edges = []
    for i in range(edgec):
        line = fin.readline().split(" ")
        u = int(line[0])
        v = int(line[1])

        adj[u].append(v)
        adj[v].append(u)
        edges.append(make_edge(u, v))

    for i in range(1, vertexc + 1):
        if len(adj[i]) > 3:
            fout.write("EI SAA\n")
            return None
    fout.write("SAAB\n")
    
    tree_dfs(1, 0, 0)
    
    for i in range(edgec):
        fout.write(edge_color[edges[i]])
        fout.write("\n")

vis = [False for i in range(MAX_V)]
cur_cycle = deque()
def find_cycle (vertex, parent):
    cur_cycle.append(vertex)
    vis[vertex] = True
    for nxt in adj[vertex]:
        if vis[nxt]:
            if nxt != parent:
                while cur_cycle[0] != nxt:
                    cur_cycle.popleft()
                return True
        elif find_cycle(nxt, vertex):
            return True
    cur_cycle.pop()
    return False

def paint_edges (vertex, cur_color):
    vis[vertex] = True

    for nxt in adj[vertex]:
        if not vis[nxt]:
            edge_color[make_edge(vertex, nxt)] = colors[cur_color]
            paint_edges(nxt, (cur_color + 1) % 3)

def graph_solve (vertexc, edgec):
    fout.write("SAAB\n")
    edges = []
    for i in range(edgec):
        line = fin.readline().split(" ")
        u = int(line[0])
        v = int(line[1])

        adj[u].append(v)
        adj[v].append(u)
        edges.append(make_edge(u, v))

    find_cycle(1, 0)

    for i in range(1, vertexc + 1):
        vis[i] = False

    for u in cur_cycle:
        vis[u] = True

    for i in range(len(cur_cycle) - 1):
        edge_color[make_edge(cur_cycle[i], cur_cycle[i + 1])] = colors[i % 2]
    edge_color[make_edge(cur_cycle[0], cur_cycle[-1])] = colors[2]

    paint_edges(cur_cycle[0], 1)
    paint_edges(cur_cycle[-1], (len(cur_cycle) - 1) % 2)
    for i in range(1, len(cur_cycle) - 1):
        paint_edges(cur_cycle[i], 2)

    for e in edges:
        if e in edge_color:
            fout.write(edge_color[e])
            fout.write("\n")
        else:
            fout.write("sinine\n")

lll = fin.readline().split(" ")
vertexc = int(lll[0])
edgec = int(lll[1])
if vertexc == edgec + 1:
    tree_solve(vertexc, edgec)
else:
    graph_solve(vertexc, edgec)
fin.close()
fout.close()
