#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <cstdlib>
using namespace std;

#ifdef DEBUG
#define log(x) { clog << x << endl; }
#else
#define log(x) { }
#endif

int res = 0;

void done(const char *msg) {
	log(msg);
	cout << res / 3.0 << endl;
	if (res == 3) {
		cerr << "OK" << endl;
	} else if (res > 0) {
		cerr << "Partial score" << endl;
	} else {
		cerr << "Wrong answer" << endl;
	}
	exit(0);
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input hint output" << endl;
		return 0;
	}
	ifstream fin(argv[1]);
	ifstream fhint(argv[2]);
	ifstream fout(argv[3]);
	// input
	int h, w;
	fin >> h >> w;
	vector<string> m1(h);
	for (int i = 0; i < h; ++i) {
		fin >> m1[i];
	}
	// hint
	int d1;
	fhint >> d1;
	// output
	int d2;
	fout >> d2;
	if (!fout) {
		done("Error reading path length");
	}
	if (d2 == d1) {
		res += 1;
		log("Length OK");
	} else {
		log("Wrong length");
	}
	vector<string> m2(h);
	int d3 = 0;
	int ci, cj;
	for (int i = 0; i < h; ++i) {
		fout >> m2[i];
		if (m2[i].length() != w) {
			done("Spoiled map (line length)");
		}
		for (int j = 0; j < w; ++j) {
			if (!(m2[i][j] == m1[i][j] || m2[i][j] == '*' && m1[i][j] == '.')) {
				done("Spoiled map (line data)");
			}
			if (m2[i][j] == '*') {
				++d3;
			}
			if (m2[i][j] == '@') {
				ci = i; cj = j;
			}
		}
	}
	if (!fout) {
		done("Spoiled map (end of file)");
	}
	string s;
	if (fout >> s) {
		done("Spoiled map (extra junk)");
	}
	// walk the path
	int d4 = 0;
	for ( ; ; ) {
		if (ci > 0 && m2[ci - 1][cj] == '*') {
			--ci;
		} else if (ci < h - 1 && m2[ci + 1][cj] == '*') {
			++ci;
		} else if (cj > 0 && m2[ci][cj - 1] == '*') {
			--cj;
		} else if (cj < w - 1 && m2[ci][cj + 1] == '*') {
			++cj;
		} else {
			break;
		}
		m2[ci][cj] = ' ';
		++d4;
	}
	if (d4 != d3) {
		done("Bad path (not really a path?)");
	}
	if (d1 != -1 && ci > 0 && ci < h - 1 && cj > 0 && cj < w - 1) {
		done("Bad path (not to exit)");
	}
	if (d1 != -1 && d4 != d1) {
		done("Bad path (not shortest)");
	}
	if (d1 == -1 && d4 != 0) {
		done("Bad path (no escape)");
	}
	res += 2;
	done("Path OK");
}
