const
   max = 100;                                            { maximal map size }
   pass = max*max;                           { code of unvisited passageway }
   camp = 0;                             { code of group's initial location }
   wall = -1;                                          { code of wall block }
   rout = -2;                                    { code of the escape route }
var                                                     
   h, w : integer;                                { height and width of map }
   map : array [1..max, 1..max] of integer;                           { map }
   found : boolean;                              { whether an exit is found }
   y, x : integer;                                { coordinates of the exit }

{ reads the input }
procedure readmap;
var f : text; i, j : integer; c : char;
begin
   assign (f, 'matksis.txt'); reset (f);              { open the input file }
   readln (f, h, w);                             { read the size of the map }
   for i := 1 to h do begin
      for j := 1 to w do begin
         read (f, c);
         case c of
            '.' : map[i, j] := pass;                           { free space }
            '#' : map[i, j] := wall;                                 { wall }
            '@' : map[i, j] := camp;                                { group }
         end;
      end;
      readln (f);                                       { skip to next line }
   end;
   close (f);                                        { close the input file }
end;

{ attempts to find a way out of the cave }
procedure findway;
var i, j : integer; f : boolean;
begin 
   found := false;                                      { no exit found yet }
   repeat                                            { look through the map }
      f := false;                                     { no new passages yet }
      for i := 1 to h do
         for j := 1 to w do
            if (map[i, j] > wall) and                   { a visited passage }
               (map[i, j] < pass) then
                  if (i = 1) or (i = h) or             { on a border of map }
                     (j = 1) or (j = w) then begin
                        found := true;                        { is an exit! }
                        y := i; x := j;                   { record location }
                  end else begin    { otherwise explore and mark neighbours }
                     if map[i - 1, j] = pass then begin
                        f := true;
                        map[i - 1, j] := map[i, j] + 1;
                     end;
                     if map[i + 1, j] = pass then begin
                        f := true;
                        map[i + 1, j] := map[i, j] + 1;
                     end;
                     if map[i, j - 1] = pass then begin
                        f := true;
                        map[i, j - 1] := map[i, j] + 1;
                     end;
                     if map[i, j + 1] = pass then begin
                        f := true;
                        map[i, j + 1] := map[i, j] + 1;
                     end;
                  end;
   until found or not f;             { an exit is found or no more passages }
end;

{ prints the map with the way marked on it, if one was found }
procedure printmap;
var f : text; i, j, d : integer;
begin
   assign (f, 'matkval.txt'); rewrite (f);           { open the output file }
   if found then begin                               { if a route was found }
      writeln (f, map[y, x]);                  { output length of the route }
         { mark the route }
      while map[y, x] > 0 do begin      { while not at the group's location }
         d := map[y, x] - 1;                    { compute the next distance }
         map[y, x] := rout;           { mark the location as being on route }
         if y > 1 then
            if map[y - 1, x] = d then begin
               y := y - 1;
               continue;
            end;
         if y < h then
            if map[y + 1, x] = d then begin
               y := y + 1;
               continue;
            end;
         if x > 1 then
            if map[y, x - 1] = d then begin
               x := x - 1;
               continue;
            end;
         if x < w then
            if map[y, x + 1] = d then begin
               x := x + 1;
               continue;
            end;
      end;
   end else
      writeln (f, -1);                                     { no route found }
   for i := 1 to h do begin                                { output the map }
      for j := 1 to w do
         case map[i, j] of
            rout : write (f, '*');                                  { route }
            wall : write (f, '#');                                   { wall }
            camp : write (f, '@');                                  { group }
         else
            write (f, '.');                      { anything else is passage }
         end;
      writeln (f);
   end;
   close (f);                                       { close the output file }
end;

begin                                                        { main program }
   readmap;                                               { read in the map }
   findway;                                            { look for the route }
   printmap;                                               { output results }
end.
