//Should get TLE
//dfs -> exponential complexity
//could trivially be made n*m times faster
#include <bits/stdc++.h>
using namespace std;
typedef long long               ll;
const int mod = 1e9+7;
#ifndef M_PI
const double M_PI = acos(-1.0);
#endif

typedef vector<string> Map;
typedef pair<int, int> Loc;

int n, m;
Map start;
pair<int, Map> ans;
std::chrono::time_point<std::chrono::system_clock> start_time;
ofstream fout;

bool on_border(Loc loc){
  return loc.first == 0 || loc.second == 0 || loc.first+1 == n || loc.second+1 == m;
}

int dist(Loc a, Loc b){
  return abs(a.first-b.first)+abs(a.second-b.second);
}

void fail(){
  fout<<"-1\n";
  for(int k=0; k<n; ++k){
    fout<<start[k]<<'\n';
  }
  exit(0);
}

void success(){
  fout<<ans.first<<"\n";
  for(int k=0; k<n; ++k){
    fout<<ans.second[k]<<'\n';
  }
  exit(0);
}

void finish(){
  if(ans.first == 1e6){
    fail();
  }
  success();
}

void check_time(){
  auto cur_time = std::chrono::system_clock::now();
  std::chrono::duration<double> diff = cur_time-start_time;
  if(diff.count() > 0.9){
    finish();
  }
}

void dfs(int c_dist, Loc loc, Map old_path){
  check_time();
  ++c_dist;
  if(c_dist > 65)
    return;
  for(int i=0; i<n; ++i){
    for(int j=0; j<m; ++j){
      Loc cur = {i, j};
      if(old_path[i][j] == '.' && dist(loc, cur) == 1){
        Map path = old_path;
        path[i][j] = '*';
        if(on_border(cur) && c_dist < ans.first){
          ans = {c_dist, path};
        }
        dfs(c_dist, cur, path);
      }
    }
  }
}

int main(){
  start_time = std::chrono::system_clock::now();
  ans.first = 1e6;
  ifstream fin("matksis.txt");
  fout = ofstream("matkval.txt");
  fin>>n>>m;
  Map vis(n);
  getline(fin, vis[0]);
  for(int i=0; i<n; ++i){
    getline(fin, vis[i]);
  }
  start = vis;
  for(int i=0; i<n; ++i){
    for(int j=0; j<m; ++j){
      if(vis[i][j] == '@'){
        Loc cur = {i, j};
        if(on_border(cur)){
          fout<<"0\n";
          for(int k=0; k<n; ++k){
            fout<<start[k]<<'\n';
          }
          return 0;
        }
        dfs(0, cur, vis);
      }
    }
  }
  finish();
}
