#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <cstdlib>
using namespace std;

#ifdef DEBUG
#define log(x) { clog << x << endl; }
#else
#define log(x) { }
#endif

void done(int res, const char *msg) {
	log(msg);
	cout << res / 2.0 << endl;
	if (res == 2) {
		cerr << "OK" << endl;
	} else if (res > 0) {
		cerr << "Non-optimal" << endl;
	} else {
		cerr << "Wrong answer" << endl;
	}
	exit(0);
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input hint output" << endl;
		return 0;
	}
	ifstream fin(argv[1]);
	ifstream fhint(argv[2]);
	ifstream fout(argv[3]);
	string s;
	// input
	int n, k;
	fin >> n >> k;
	vector<int> x(k);
	for (int i = 0; i < k; ++i) {
		fin >> x[i];
	}
	// hint
	int s1 = 0;
	while (fhint >> s) {
		++s1;
	}
	// output
	vector<int> a, b, c;
	for (int i = 0; i < n; ++i) {
		a.push_back(n - i);
	}
	int s2 = 0;
	while (fout >> s) {
		if (s.length() != 4 || s[1] != '-' || s[2] != '>') {
			done(0, "Move format error");
		}
		vector<int> *f = 0, *t = 0;
		switch (s[0]) {
			case 'A': f = &a; break;
			case 'B': f = &b; break;
			case 'C': f = &c; break;
			default: done(0, "Invalid source rack");
		}
		switch (s[3]) {
			case 'A': t = &a; break;
			case 'B': t = &b; break;
			case 'C': t = &c; break;
			default: done(0, "Invalid target rack");
		}
		if (f->size() == 0) {
			done(0, "Source rack empty");
		}
		if (t->size() > 0 && f->back() > t->back()) {
			done(0, "Larger server on top of smaller");
		}
		t->push_back(f->back());
		f->pop_back();
		++s2;
	}
	if (a.size() != 0) {
		done(0, "A rack not empty");
	}
	for (int i = 0; i < k; ++i) {
		if (b.back() < x[i]) {
			done(0, "Y server in B rack");
		}
		if (b.back() > x[i]) {
			done(0, "X server in C rack");
		}
		b.pop_back();
	}
	if (b.size() != 0) {
		done(0, "Y server in B rack");
	}
	if (s2 > s1) {
		done(1, "OK, too many moves");
	} else {
		done(2, "OK");
	}
}
